<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Update #14                                              |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Users
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function AdminRegistrationQueue
 * A function to manage the registration queue
 * @author Philipp Louis Esselbach
 */
function AdminRegistrationQueue( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_users;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;

	if( $options[ 0 ] )
	{
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_users[ 'ERROR' ], $words_users[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletequeueuser" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_usersqueue WHERE userqueue_id = '" . $options[ 1 ] . "'" );
		$options[ 0 ] = "";
	}

	if( $options[ 0 ] == "editqueueuser" )
	{
		include( "admineditqueueuser.php" );
		AdminEditQueueUser( $options[ 1 ], 0 );
	}

	if( !$options[ 0 ] )
	{
		$security_hash = $system -> adminhashput();

		$input_search_user = ( isset( $_GET[ 'input_search_user' ] ) ) ? $security -> checkvar( $_GET[ 'input_search_user' ] ) : "" ;
		$input_search_email = ( isset( $_GET[ 'input_search_email' ] ) ) ? $security -> checkvar( $_GET[ 'input_search_email' ] ) : "" ;
		$input_search_date = ( isset( $_GET[ 'input_search_date' ] ) ) ? $security -> checknum( $_GET[ 'input_search_date' ] ) : "" ;
		$input_search_sort = ( isset( $_GET[ 'input_search_sort' ] ) ) ? $security -> checknum( $_GET[ 'input_search_sort' ] ) : "" ;
		$input_search_order = ( isset( $_GET[ 'input_search_order' ] ) ) ? $security -> checknum( $_GET[ 'input_search_order' ] ) : "" ;
		$input_search_page = ( isset( $_GET[ 'input_search_page' ] ) ) ? $security -> checknum( $_GET[ 'input_search_page' ] ) : "" ;
		$input_search_pageentries = ( isset( $_GET[ 'input_search_pageentries' ] ) ) ? $security -> checknum( $_GET[ 'input_search_pageentries' ] ) : "" ;
		$input_query = array();

		if( $input_search_user )
		{
			$input_query[ ] = "(userqueue_name LIKE '%" . $input_search_user . "%')";
		}

		if( $input_search_email )
		{
			$input_query[ ] = "(userqueue_email LIKE '%" . $input_search_email . "%')";
		}

		if( $input_search_date )
		{
			if( $input_search_date == 1 )
			{
				$input_search_range = 86400;
			}

			if( $input_search_date == 2 )
			{
				$input_search_range = 172800;
			}

			if( $input_search_date == 3 )
			{
				$input_search_range = 604800;
			}

			if( $input_search_date == 4 )
			{
				$input_search_range = 2677400;
			}

			$input_search_date_db = mktime() - $input_search_range;
			$input_search_date_db = date( "Y-m-d H:i:s", $input_search_date_db );
			$input_query[ ] = "userqueue_regtime > " . $input_search_date_db;
		}

		if( $input_query )
		{
			$input_full_query = "WHERE " . join( " AND ", $input_query );
		}
		else
		{
			$input_full_query = "";
		}

		if( $input_search_sort )
		{
			if( $input_search_sort == 1 )
			{
				$input_sort_query = "userqueue_name";
			}

			if( $input_search_sort == 2 )
			{
				$input_sort_query = "userqueue_email";
			}

			if( $input_search_sort == 3 )
			{
				$input_sort_query = "user_regtime";
			}

			if( $input_search_sort == 4 )
			{
				$input_sort_query = "user_birthday";
			}

			if( $input_search_sort == 5 )
			{
				$input_sort_query = "user_regip";
			}
		}
		else
		{
			$input_sort_query = "userqueue_id";
		}

		if( !$input_search_order )
		{
			$input_sort_query .= " DESC";
		}

		if( !$input_search_pageentries )
		{
			$input_pageentries_query = 50;
		}
		elseif( $input_search_pageentries == 1)
		{
			$input_pageentries_query = 100;
		}
		elseif( $input_search_pageentries == 2)
		{
			$input_pageentries_query = 250;
		}
		elseif( $input_search_pageentries == 3)
		{
			$input_pageentries_query = 500;
		}
		elseif( $input_search_pageentries == 4)
		{
			$input_pageentries_query = 1000;
		}

		$html -> makeheader( $words_users[ 'REGISTRATION_QUEUE' ] );
		$html -> deleteinit( $words_users[ 'ARE_YOU_SURE' ] );
		$html -> checkinit();
		$html -> makesubheader();
		$html -> makegroupmenu( "users" );
		$html -> makeformheader( $words_users[ 'REGISTRATION_QUEUE' ], "users", "usersearch", "get" );
		echo $words_users[ 'SEARCH_QUEUE_DATABASE' ] . "<br />";
		echo "<strong>" . $words_users[ 'USER_NAME' ] . ":</strong> <input name=\"input_search_user\" size=\"32\" value=\"" . htmlspecialchars( stripslashes( $input_search_user ) ) . "\" /> ";
		echo "<strong>" . $words_users[ 'EMAIL_ADDRESS' ] . ":</strong> <input name=\"input_search_email\" size=\"32\" value=\"" . htmlspecialchars( stripslashes( $input_search_email ) ) . "\" /> ";
		echo "<input type=\"hidden\" name=\"action\" value=\"registrationqueue\" /><input type=\"submit\" class=\"button\" value=\"" . $words_users[ 'GO' ] . "\" /><br />";
		( !$input_search_date ) ? $range_all = "selected=\"selected\" " : $range_all = "" ;
		( $input_search_date == 1 ) ? $range_today = "selected=\"selected\" " : $range_today = "" ;
		( $input_search_date == 2 ) ? $range_yesterday = "selected=\"selected\" " : $range_yesterday = "" ;
		( $input_search_date == 3 ) ? $range_lastweek = "selected=\"selected\" " : $range_lastweek = "" ;
		( $input_search_date == 4 ) ? $range_lastmonth = "selected=\"selected\" " : $range_lastmonth = "" ;
		echo "<strong>" . $words_users[ 'REGISTERED' ] . ":</strong> <select size=\"1\" name=\"input_search_date\">";
		echo "<option " . $range_all . "value=\"0\">" . $words_users[ 'ALL' ] . "</option>";
		echo "<option " . $range_today . "value=\"1\">" . $words_users[ 'TODAY' ] . "</option>";
		echo "<option " . $range_yesterday . "value=\"2\">" . $words_users[ 'YESTERDAY' ] . "</option>";
		echo "<option " . $range_lastweek . "value=\"3\">" . $words_users[ 'LASTWEEK' ] . "</option>";
		echo "<option " . $range_lastmonth . "value=\"4\">" . $words_users[ 'LASTMONTH' ] . "</option>";
		echo "</select> ";
		( !$input_search_sort ) ? $sort_id = "selected=\"selected\" " : $sort_id = "" ;
		( $input_search_sort == 1 ) ? $sort_user_name = "selected=\"selected\" " : $sort_user_name = "" ;
		( $input_search_sort == 2 ) ? $sort_email_address = "selected=\"selected\" " : $sort_email_address = "" ;
		( $input_search_sort == 3 ) ? $sort_registration_date = "selected=\"selected\" " : $sort_registration_date = "" ;
		( $input_search_sort == 4 ) ? $sort_birthday = "selected=\"selected\" " : $sort_birthday = "" ;
		( $input_search_sort == 5 ) ? $sort_registration_ip = "selected=\"selected\" " : $sort_registration_ip = "" ;
		echo "<strong>" . $words_users[ 'SORT_BY' ] . ":</strong> <select size=\"1\" name=\"input_search_sort\">";
		echo "<option " . $sort_id . "value=\"0\">" . $words_users[ 'ID' ] . "</option>";
		echo "<option " . $sort_user_name . "value=\"1\">" . $words_users[ 'USER_NAME' ] . "</option>";
		echo "<option " . $sort_email_address . "value=\"2\">" . $words_users[ 'EMAIL_ADDRESS' ] . "</option>";
		echo "<option " . $sort_registration_date . "value=\"3\">" . $words_users[ 'REGISTRATION_DATE' ] . "</option>";
		echo "<option " . $sort_birthday . "value=\"4\">" . $words_users[ 'BIRTHDAY' ] . "</option>";
		echo "<option " . $sort_registration_ip . "value=\"5\">" . $words_users[ 'REGISTRATION_IP' ] . "</option>";
		echo "</select> ";
		( !$input_search_order ) ? $sort_descending = "selected=\"selected\" " : $sort_descending = "" ;
		( $input_search_order == 1 ) ? $sort_ascending = "selected=\"selected\" " : $sort_ascending = "" ;
		echo "<select size=\"1\" name=\"input_search_order\">";
		echo "<option " . $sort_descending . "value=\"0\">" . $words_users[ 'DESCENDING' ] . "</option>";
		echo "<option " . $sort_ascending . "value=\"1\">" . $words_users[ 'ASCENDING' ] . "</option>";
		echo "</select><br />";
		( !$input_search_pageentries ) ? $entries_50 = "selected=\"selected\" " : $entries_50 = "" ;
		( $input_search_pageentries == 1 ) ? $entries_100 = "selected=\"selected\" " : $entries_100 = "" ;
		( $input_search_pageentries == 2 ) ? $entries_250 = "selected=\"selected\" " : $entries_250 = "" ;
		( $input_search_pageentries == 3 ) ? $entries_500 = "selected=\"selected\" " : $entries_500 = "" ;
		( $input_search_pageentries == 4 ) ? $entries_1000 = "selected=\"selected\" " : $entries_1000 = "" ;
		echo "<strong>" . $words_users[ 'ENTRIES_PAGE' ] . ":</strong> <select size=\"1\" name=\"input_search_pageentries\">";
		echo "<option " . $entries_50 . "value=\"0\">50</option>";
		echo "<option " . $entries_100 . "value=\"1\">100</option>";
		echo "<option " . $entries_250 . "value=\"2\">250</option>";
		echo "<option " . $entries_500 . "value=\"3\">500</option>";
		echo "<option " . $entries_1000 . "value=\"4\">1000</option>";
		echo "</select> ";
		$query = $database -> dbquery( "SELECT COUNT(userqueue_id) FROM " . DB_PREFIX . "esselbach_ct_usersqueue " . $input_full_query . " ORDER BY " . $input_sort_query );
		list( $all_pages ) = $database -> dbrow( $query );

		if( $input_search_page )
		{
			$input_search_dbpage = $input_search_page - 1;
			$page = $input_search_dbpage * $input_pageentries_query;
		}
		else
		{
			$page = 0;
		}

		$all_pages_rounded = ceil( $all_pages / $input_pageentries_query );
		$query = $database -> dbquery( "SELECT userqueue_name, userqueue_loginname, userqueue_email, userqueue_id, userqueue_ip FROM " . DB_PREFIX . "esselbach_ct_usersqueue " . $input_full_query . " ORDER BY " . $input_sort_query . " LIMIT " . $page . "," . $input_pageentries_query );
		$pages = $database -> dbrows( $query );

		if( $pages )
		{
			$html -> makeformsubfooter();

			if( ( $page < $all_pages ) and( $all_pages_rounded > 1 ) )
			{
				echo "<span class=\"pagelink\">" . $all_pages_rounded . " " . $words_users[ 'PAGES' ] . "</span> ";
				$html -> printpages( $all_pages_rounded, "index.php?action=registrationqueue&amp;input_search_user=" . htmlspecialchars( $input_search_user ) . "&amp;input_search_email=" . htmlspecialchars( $input_search_email ) . "&amp;input_search_date=" . htmlspecialchars( $input_search_date ) . "&amp;input_search_sort=" . $input_search_sort . "&amp;input_search_order=" . $input_search_order . "&amp;input_search_pageentries=" . $input_search_pageentries . "&amp;input_search_page", $input_search_page );
			}

			echo "<h1>" . $words_users[ 'USERS' ] . "</h1>";
			$html -> table5header( $words_users[ 'USER_ID' ], $words_users[ 'USER_NAME_LOGIN_NAME' ], $words_users[ 'REGISTRATION_IP' ], $words_users[ 'EMAIL_ADDRESS' ] );

			while( list( $user_name, $user_loginname, $user_email, $user_id, $user_ip ) = $database -> dbrow( $query ) )
			{
				$html -> table5middle( $user_id, htmlspecialchars( $user_name ) . " (" . htmlspecialchars( $user_loginname ) . ")", htmlspecialchars( $user_ip ), htmlspecialchars( $user_email ), "registrationqueue&amp;opts=editqueueuser-" . $user_id . "-" . $security_hash, "registrationqueue&amp;opts=deletequeueuser-" . $user_id . "-" . $security_hash );
			}

			$html -> table5close( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"registrationqueueoptions\" /><select size=\"1\" name=\"input_option\"><optgroup label=\"" . $words_users[ 'REGISTRATION_QUEUE_OPTIONS' ] . "\"><option value=\"0\">" . $words_users[ 'DELETE_CHECKED' ] . "</option><option value=\"1\">" . $words_users[ 'ACTIVATE_CHECKED' ] . "</option></optgroup></select><input type=\"submit\" class=\"button\" value=\"" . $words_users[ 'GO' ] . "\" />" );
			$html -> maketablefooter();
			$html -> makeformsubfooter();

			if( ( $page < $all_pages ) and( $all_pages_rounded > 1 ) )
			{
				echo "<span class=\"pagelink\">" . $all_pages_rounded . " " . $words_users[ 'PAGES' ] . "</span> ";
				$html -> printpages( $all_pages_rounded, "index.php?action=registrationqueue&amp;input_search_user=" . htmlspecialchars( $input_search_user ) . "&amp;input_search_email=" . htmlspecialchars( $input_search_email ) . "&amp;input_search_date=" . htmlspecialchars( $input_search_date ) . "&amp;input_search_sort=" . $input_search_sort . "&amp;input_search_order=" . $input_search_order . "&amp;input_search_pageentries=" . $input_search_pageentries . "&amp;input_search_page", $input_search_page );
			}
		}
		else
		{
			echo "<br />" . $words_users[ 'NO_MATCHES' ] . "</div>";
		}

		echo "</div>";
	}
}
?>